SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest methodsFor: 'actors' stamp: 'AlejandraRodriguez 5/1/2013 19:53'!
blueGhost

	| blueGhost |
	blueGhost := Ghost new.
	^ blueGhost initializeWithX: 20 andY: 20! !

!PacManTest methodsFor: 'actors' stamp: 'AlejandraRodriguez 5/1/2013 19:54'!
blueberry

	| blueBerry |
	blueBerry := Fruit new.
	^ blueBerry initializeWithX: 15 andY: 35! !

!PacManTest methodsFor: 'movements' stamp: 'EzequielBarrios 4/29/2013 20:57'!
down

	^0@(-1)! !

!PacManTest methodsFor: 'construction block types' stamp: 'EzequielBarrios 4/29/2013 21:19'!
ghostHouseDoorType

	^ GhostHouseDoorCellType new! !

!PacManTest methodsFor: 'movements' stamp: 'EzequielBarrios 4/29/2013 20:58'!
left

	^ (-1)@0.! !

!PacManTest methodsFor: 'construction block types' stamp: 'EzequielBarrios 4/29/2013 21:48'!
leftTransporterType

	^ LeftTransporterCellType new! !

!PacManTest methodsFor: 'actors' stamp: 'AlejandraRodriguez 5/1/2013 19:54'!
pacman

	| pacman |
	pacman := Pacman new.
	^ pacman initializeWithX: 40 andY: 1! !

!PacManTest methodsFor: 'movements' stamp: 'EzequielBarrios 4/29/2013 20:57'!
right

	^1@0! !

!PacManTest methodsFor: 'construction block types' stamp: 'EzequielBarrios 4/29/2013 21:05'!
spaceType

		^ SpaceCellType new 
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'EzequielBarrios 5/6/2013 18:54'!
test06aFruitCanEnterGhostHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'EzequielBarrios 4/29/2013 20:58'!
up

	^ 0@1! !

!PacManTest methodsFor: 'construction block types' stamp: 'EzequielBarrios 4/29/2013 20:41'!
wallType

	^ WallCellType new ! !

Object subclass: #PacManGameCellType
	instanceVariableNames: 'pacmanGame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

PacManGameCellType subclass: #GhostHouseDoorCellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:30'!
nextPositionFor: anActor going: aDirection
	 ^ anActor nextPositionGoingToGhostHouseDoorInDirection: aDirection solicitedBy: self! !

!GhostHouseDoorCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:45'!
nextPositionToAFruit: aFruit goingInDirection: aDirection
	 ^ aFruit position + aDirection! !

!GhostHouseDoorCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:41'!
nextPositionToAGhost: aGhost goingInDirection: aDirection
	 ^ aGhost position + aDirection! !

!GhostHouseDoorCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:41'!
nextPositionToAPacman: aPacman goingInDirection: aDirection
	 ^ aPacman position! !

PacManGameCellType subclass: #LeftTransporterCellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!LeftTransporterCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:44'!
nextPositionFor: anActor going: aDirection
	 ^  anActor nextPositionGoingToLeftTransporterInDirection: aDirection solicitedBy: self! !

!LeftTransporterCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:46'!
nextPositionToAFruit: aFruit goingInDirection: aDirection
	 ^ 5@10! !

!LeftTransporterCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:45'!
nextPositionToAGhost: aGhost goingInDirection: aDirection
	 ^ aGhost position! !

!LeftTransporterCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:47'!
nextPositionToAPacman: aPacman goingInDirection: aDirection
	 ^ 3@10! !

!PacManGameCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:42'!
nextPositionToAFruit: aFruit goingInDirection: aDirection
	self subclassResponsibility ! !

!PacManGameCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:42'!
nextPositionToAGhost: aGhost goingInDirection: aDirection
	self subclassResponsibility ! !

!PacManGameCellType methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:42'!
nextPositionToAPacman: aPacman goingInDirection: aDirection
	self subclassResponsibility ! !

PacManGameCellType subclass: #SpaceCellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceCellType methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 17:58'!
nextPositionFor: anActor going: aDirection 
	^ anActor position + aDirection.! !

PacManGameCellType subclass: #WallCellType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallCellType methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:43'!
nextPositionFor: anActor going: aDirection

	^ anActor position! !

Object subclass: #PacmanGameActor
	instanceVariableNames: 'position type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

PacmanGameActor subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:32'!
nextPositionGoingToGhostHouseDoorInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAFruit: self goingInDirection: aDirection! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:35'!
nextPositionGoingToLeftTransporterInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAFruit: self goingInDirection: aDirection! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:36'!
nextPositionGoingToSpaceCellInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAFruit: self goingInDirection: aDirection! !

!Fruit methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:37'!
nextPositionGoingToWallInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAFruit: self goingInDirection: aDirection! !

PacmanGameActor subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:33'!
nextPositionGoingToGhostHouseDoorInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAGhost: self goingInDirection: aDirection! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:35'!
nextPositionGoingToLeftTransporterInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAGhost: self goingInDirection: aDirection! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:36'!
nextPositionGoingToSpaceCellInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAGhost: self goingInDirection: aDirection! !

!Ghost methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:37'!
nextPositionGoingToWallInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAGhost: self goingInDirection: aDirection! !

PacmanGameActor subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:33'!
nextPositionGoingToGhostHouseDoorInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAPacman: self goingInDirection: aDirection! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:35'!
nextPositionGoingToLeftTransporterInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAPacman: self goingInDirection: aDirection! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:39'!
nextPositionGoingToSpaceCellInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAPacman: self goingInDirection: aDirection! !

!Pacman methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:38'!
nextPositionGoingToWallInDirection: aDirection solicitedBy: aCellType
	^ aCellType nextPositionToAPacman: self goingInDirection: aDirection! !

!PacmanGameActor methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 5/6/2013 18:00'!
initializeWithX: xPosition andY: yPosition

	super initialize.
	position := Point x: xPosition y: yPosition.! !

!PacmanGameActor methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:31'!
nextPositionGoingToGhostHouseDoorInDirection: aDirection solicitedBy: aCellType
	self subclassResponsibility ! !

!PacmanGameActor methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:38'!
nextPositionGoingToLeftTransporterInDirection: aDirection solicitedBy: aCellType
	self subclassResponsibility ! !

!PacmanGameActor methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:38'!
nextPositionGoingToSpaceCellInDirection: aDirection solicitedBy: aCellType
	self subclassResponsibility ! !

!PacmanGameActor methodsFor: 'as yet unclassified' stamp: 'AlejandraRodriguez 5/1/2013 19:38'!
nextPositionGoingToWallInDirection: aDirection solicitedBy: aCellType
	self subclassResponsibility ! !

!PacmanGameActor methodsFor: 'as yet unclassified' stamp: 'EzequielBarrios 4/29/2013 21:30'!
position
	^ position! !
